com.io7m.jregions.core.parameterized.areas

## Class PAreaBI<S>

- java.lang.Object
- - com.io7m.jregions.core.parameterized.areas.PAreaBI<S>

- Type Parameters:
    `S` - A phantom type parameter indicating the coordinate space of the area
  All Implemented Interfaces:
    PAreaBIType<S>

      @Generated(value={"Immutables.generator","PAreaBIType<S>"})
      public final class PAreaBI<S>
      extends Object
      implements PAreaBIType<S>

  An area with `BigInteger` coordinates.

  The coordinates of the area are given in half-closed form. That is, `minimumX()` refers to the minimum inclusive value on the X axis, and `maximumX()` refers to the maximum exclusive value on the X axis. Likewise for the Y axis.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `PAreaBI.Builder<S>` Builds instances of type `PAreaBI`.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static <S> PAreaBI.Builder<S>` | `builder()` Creates a builder for `PAreaBI`.
    `boolean` | `equals(Object another)` This instance is equal to all instances of `PAreaBI` that have equal attribute values.
    `int` | `hashCode()` Computes a hash code from attributes: `minimumX`, `maximumX`, `minimumY`, `maximumY`.
    `BigInteger` | `height()`
    `BigInteger` | `maximumX()`
    `BigInteger` | `maximumY()`
    `BigInteger` | `minimumX()`
    `BigInteger` | `minimumY()`
    `static <S> PAreaBI<S>` | `of(BigInteger minimumX, BigInteger maximumX, BigInteger minimumY, BigInteger maximumY)` Construct a new immutable `PAreaBI` instance.
    `String` | `toString()` Prints the immutable value `PAreaBI` with attribute values.
    `BigInteger` | `width()`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface com.io7m.jregions.core.parameterized.areas.PAreaBIType

      `checkPreconditions`

- - ### Method Detail

    - #### minimumX

          public BigInteger minimumX()

      Specified by:
        `minimumX` in interface `PAreaBIType<S>`
      Returns:
        The value on the X axis of the minimum edge of the box (inclusive)

    - #### maximumX

          public BigInteger maximumX()

      Specified by:
        `maximumX` in interface `PAreaBIType<S>`
      Returns:
        The value on the X axis of the maximum edge of the box (exclusive)

    - #### minimumY

          public BigInteger minimumY()

      Specified by:
        `minimumY` in interface `PAreaBIType<S>`
      Returns:
        The value on the Y axis of the minimum edge of the box (inclusive)

    - #### maximumY

          public BigInteger maximumY()

      Specified by:
        `maximumY` in interface `PAreaBIType<S>`
      Returns:
        The value on the Y axis of the maximum edge of the box (exclusive)

    - #### equals

          public boolean equals(Object another)

      This instance is equal to all instances of `PAreaBI` that have equal attribute values.
      Overrides:
        `equals` in class `Object`
      Returns:
        `true` if `this` is equal to `another` instance

    - #### hashCode

          public int hashCode()

      Computes a hash code from attributes: `minimumX`, `maximumX`, `minimumY`, `maximumY`.
      Overrides:
        `hashCode` in class `Object`
      Returns:
        hashCode value

    - #### toString

          public String toString()

      Prints the immutable value `PAreaBI` with attribute values.
      Overrides:
        `toString` in class `Object`
      Returns:
        A string representation of the value

    - #### width

          public BigInteger width()

      Returns a lazily initialized value of the `width` attribute. Initialized once and only once and stored for subsequent access with proper synchronization.

      Specified by:
        `width` in interface `PAreaBIType<S>`
      Returns:
        A lazily initialized value of the `l.name` attribute

    - #### height

          public BigInteger height()

      Returns a lazily initialized value of the `height` attribute. Initialized once and only once and stored for subsequent access with proper synchronization.

      Specified by:
        `height` in interface `PAreaBIType<S>`
      Returns:
        A lazily initialized value of the `l.name` attribute

    - #### of

          public static <S> PAreaBI<S> of(BigInteger minimumX,
                                          BigInteger maximumX,
                                          BigInteger minimumY,
                                          BigInteger maximumY)

      Construct a new immutable `PAreaBI` instance.
      Parameters:
        `minimumX` - The value for the `minimumX` attribute
        `maximumX` - The value for the `maximumX` attribute
        `minimumY` - The value for the `minimumY` attribute
        `maximumY` - The value for the `maximumY` attribute
      Returns:
        An immutable PAreaBI instance

    - #### builder

          public static <S> PAreaBI.Builder<S> builder()

      Creates a builder for `PAreaBI`.
      Type Parameters:
        `S` - generic parameter S
      Returns:
        A new PAreaBI builder

Copyright © 2017 <code@io7m.com> http://io7m.com